=== tests/cli/requirements.txt ===
pytest==6.2.5
