=== debian/changelog ===
librepcb (1.2.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake4. (Closes: #1113195)

 -- Tobias Frost <tobi@debian.org>  Fri, 17 Oct 2025 18:06:58 +0200

librepcb (1.2.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * d/copyright: Replace BSD-3-clause with correct variant

 -- Bastian Germann <bage@debian.org>  Thu, 21 Aug 2025 16:06:02 +0200

librepcb (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Mon, 02 Dec 2024 18:08:13 +0100
