=== debian/watch ===
version=4

# the URL is broken up into 3 lines
# <a href="https://download.librepcb.org/releases/0.1.4
# /librepcb-0.1.4
# -source.zip">sources</a>.

# Repack as DFSG; also use xz compression

opts=repacksuffix=+dfsg,repack,compression=xz,pgpsigurlmangle=s/$/.asc/ \
 https://librepcb.org/download/ https://download\.librepcb\.org/releases/\d\.\d\.\d/librepcb-(\d\.\d\.\d)-source.zip
